function formatStringWithParams(str, params){
	var i, temp = str;
	try{
		for(i=0; i<params.length; i++){
			temp = temp.replace('{'+i+'}', params[i]);
		}
	}catch(ex){
		_DEBUG("convertPrayersToTimes: " + ex.Description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
	return temp;
}

function dhtmlLoadScript1(url){
	_DEBUG("dhtmlLoadScript: " + url);

   var e = document.createElement("script");
   e.src = url;
   e.type="text/javascript";
   document.getElementsByTagName("head")[0].appendChild(e); 
}

function dhtmlLoadScript(url){
	// Remove old file if exists
	var n=document.getElementsByTagName("head")[0].childNodes;
	for(i=0;i<n.length;i++){
		if(n[i].id == "stringsFile"){
			document.getElementsByTagName("head")[0].removeChild(n[i]);
			break;
		}
	}
	
	// Add a new one
	var e = document.createElement("script");
	e.src = url;
	e.type="text/javascript";
	e.id = "stringFile";
	document.getElementsByTagName("head")[0].appendChild(e);
}


function loadStrings(){
	_DEBUG("loadStrings: Loading strings: " + System.Gadget.Settings.readString("Language"));

	try{
		if(System.Gadget.Settings.readString("Language") == '' || System.Gadget.Settings.readString("Language") == 'en'){
			dhtmlLoadScript('../includes/strings.js');
		}else{
			dhtmlLoadScript('../'+ System.Gadget.Settings.readString("Language") + '/includes/strings.js');	
		}
	}catch(ex){
		_DEBUG("loadStrings:ex1:" + ex.description);
		dhtmlLoadScript('../includes/strings.js');
	}	
	
	try{
		prayerNames[0] = L_FAJR;
		prayerNames[1] = L_SUNRISE;
		prayerNames[2] = L_DUHR;
		prayerNames[3] = L_ASR;
		prayerNames[4] = L_MAGHRIB;
		prayerNames[5] = L_ISHA;

		//document.documentElement.style.direction = L_DIR;
		document.getElementById("contents").dir = L_DIR;
		document.getElementById("HijriDateLabel").innerText = L_HIJRI_DATE_TITLE;
		document.getElementById("QiblaAngleLebel").innerText = L_QIBLA_ANGLE_TITLE;

		for(i=0;i<prayerNames.length;i++){
			document.getElementById("Label"+i).innerText = prayerNames[i];
			if(L_DIR == 'rtl'){
				document.getElementById("prayer"+i).style.textAlign = 'left';
				document.getElementById("Label"+i).style.textAlign = 'right';
			} else {
				document.getElementById("prayer"+i).style.textAlign = 'right';
				document.getElementById("Label"+i).style.textAlign = 'left';
			}
		}
	}catch(ex){
		_DEBUG("loadStrings:ex2: " + ex.description);

	}
}
