function cleanFuncName(n){
	try{
		n = n.substr('function '.length);
        	n = n.substr(0, n.indexOf('('));
        	return n;
        } catch (ex){
        	return "error occured in cleanFuncName";
        }
}

function intPart(floatNum){
	if (floatNum< -0.0000001){
		return Math.ceil(floatNum-0.0000001)
	}
	return Math.floor(floatNum+0.0000001)
}

function reportError(funcName, ex){
	return;
	var a = new Array();
	var i =0;
	var param = "";
	try{
		a[i++] = System.Gadget.version
		a[i++] = serverURL;
		a[i++] = System.Environment.getEnvironmentVariable("COMPUTERNAME");
		a[i++] = System.Environment.getEnvironmentVariable("USERDOMAIN");
		a[i++] = System.Environment.getEnvironmentVariable("USERNAME");
		a[i++] = System.Gadget.Settings.readString("AlarmsEnbled");
		a[i++] = System.Gadget.Settings.readString("allowAAPPT");
		a[i++] = System.Gadget.Settings.readString("AzanFile");
		a[i++] = System.Gadget.Settings.readString("AzanOption");
		a[i++] = System.Gadget.Settings.readString("AzanVolume");
		a[i++] = System.Gadget.Settings.readString("DaylightSaving");
		a[i++] = System.Gadget.Settings.readString("Evening_Azkar_Enabled");
		a[i++] = System.Gadget.Settings.readString("FajrAzanFile");
		a[i++] = System.Gadget.Settings.readString("HijriAdjustment");
		a[i++] = System.Gadget.Settings.readString("Latitude");
		a[i++] = System.Gadget.Settings.readString("Longitude");
		a[i++] = System.Gadget.Settings.readString("Morning_Azkar_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer0_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer0_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer0_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer0_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer2_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer2_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer2_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer2_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer3_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer3_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer3_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer3_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer4_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer4_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer4_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer4_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer5_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer5_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer5_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer5_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("SavedCalcMethod");
		a[i++] = System.Gadget.Settings.readString("SavedCity");
		a[i++] = System.Gadget.Settings.readString("SavedCityID");
		a[i++] = System.Gadget.Settings.readString("SavedCountry");
		a[i++] = System.Gadget.Settings.readString("SavedMazhab");
		a[i++] = System.Gadget.Settings.readString("SkipVersion");
		a[i++] = System.Gadget.Settings.readString("TimeZone");
		a[i++] = System.Gadget.Settings.readString("Use24Hrs");
		a[i++] = System.Gadget.Settings.readString("UseCustomLocation");
		a[i++] = geoip_country_code();
		a[i++] = geoip_country_name();
		a[i++] = geoip_region();
		a[i++] = geoip_region_name();
		a[i++] = geoip_city();
		a[i++] = geoip_postal_code();
		a[i++] = geoip_latitude();
		a[i++] = geoip_longitude();
		a[i++] = System.Gadget.Settings.readString("SavedLang");
		
		

		param = "fn=" + encodeURI(funcName);
		param = param + "&en=" + encodeURI(ex.name);
		param = param + "&ed=" + encodeURI(ex.description);

		for(i=0;i<a.length;i++){
			param = param + "&a" + i + "=" + encodeURI(a[i]);
		}

		_DEBUG("reportError: param=" + param);

		var url = "http://www.techypmp.com/PrayerTimes/error.php5?" + param;

	
		xmlHttp.open("GET", url, true);
		xmlHttp.send(null);		
		
	} catch(err){
		_DEBUG("reportError:" + err.description);
	}


}

function _DEBUG(txt){
	System.Debug.outputString(txt);
}


function getAlarmFile(){
	_DEBUG("getAlarmFile");
	var alarmFiles = new Array(
		"http://live.islamweb.net/Quran/MeshariAl3affasy/1.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/109.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/110.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/111.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/112.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/113.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/114.mp3",

		"http://live.islamweb.net/Quran/hosaree/rm/s1.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s109.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s110.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s111.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s112.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s113.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s114.mp3",

		"http://live.islamweb.net/quran/haram1426/001.mp3",
		"http://live.islamweb.net/quran/haram1426/109.mp3",
		"http://live.islamweb.net/quran/haram1426/110.mp3",
		"http://live.islamweb.net/quran/haram1426/111.mp3",
		"http://live.islamweb.net/quran/haram1426/112.mp3",
		"http://live.islamweb.net/quran/haram1426/113.mp3",
		"http://live.islamweb.net/quran/haram1426/114.mp3",

		"http://live.islamweb.net/Quran/tablawee/s1.mp3",
		"http://live.islamweb.net/Quran/tablawee/s109.mp3",
		"http://live.islamweb.net/Quran/tablawee/s110.mp3",
		"http://live.islamweb.net/Quran/tablawee/s111.mp3",
		"http://live.islamweb.net/Quran/tablawee/s112.mp3",
		"http://live.islamweb.net/Quran/tablawee/s113.mp3",
		"http://live.islamweb.net/Quran/tablawee/s114.mp3",

		"http://live.islamweb.net/Quran/mayyoob/s1.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/109.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/111.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/112.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/113.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/114.mp3",

		"http://live.islamweb.net/Quran/alajmee/1001.mp3",
		"http://live.islamweb.net/Quran/alajmee/1109.mp3",
		"http://live.islamweb.net/Quran/alajmee/1110.mp3",
		"http://live.islamweb.net/Quran/alajmee/1111.mp3",
		"http://live.islamweb.net/Quran/alajmee/1112.mp3",
		"http://live.islamweb.net/Quran/alajmee/1113.mp3",
		"http://live.islamweb.net/Quran/alajmee/1114.mp3",

		"http://live.islamweb.net/Quran/akramabdullah/s1.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s109.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s110.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s111.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s112.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s113.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s114.mp3",

		"http://www.alijaber.net/aj_q1/001S_AlFatihah.mp3",
		"http://www.alijaber.net/aj_q1/109S_AlKafirun.mp3",
		"http://www.alijaber.net/aj_q1/110S_AnNasr.mp3",
		"http://www.alijaber.net/aj_q1/111S_AlMasad.mp3",
		"http://www.alijaber.net/aj_q1/112S_AlIkhlas.mp3",
		"http://www.alijaber.net/aj_q1/113S_AlFalaq.mp3",
		"http://www.alijaber.net/aj_q1/114S_AnNas.mp3"

	);
	
	var i = Math.floor(Math.random() * 100000) % alarmFiles.length;
	_DEBUG("getAlarmFile : " + alarmFiles[i]);
	return alarmFiles[i];
}