function cleanFuncName(n){
	try{
		n = n.substr('function '.length);
        	n = n.substr(0, n.indexOf('('));
        	return n;
        } catch (ex){
        	return "error occured in cleanFuncName";
        }
}

function intPart(floatNum){
	if (floatNum< -0.0000001){
		return Math.ceil(floatNum-0.0000001)
	}
	return Math.floor(floatNum+0.0000001)
}

function reportError(funcName, ex){
	return;
	var a = new Array();
	var i =0;
	var param = "";
	try{
		a[i++] = System.Gadget.version
		a[i++] = serverURL;
		a[i++] = System.Environment.getEnvironmentVariable("COMPUTERNAME");
		a[i++] = System.Environment.getEnvironmentVariable("USERDOMAIN");
		a[i++] = System.Environment.getEnvironmentVariable("USERNAME");
		a[i++] = System.Gadget.Settings.readString("AlarmsEnbled");
		a[i++] = System.Gadget.Settings.readString("allowAAPPT");
		a[i++] = System.Gadget.Settings.readString("AzanFile");
		a[i++] = System.Gadget.Settings.readString("AzanOption");
		a[i++] = System.Gadget.Settings.readString("AzanVolume");
		a[i++] = System.Gadget.Settings.readString("DaylightSaving");
		a[i++] = System.Gadget.Settings.readString("Evening_Azkar_Enabled");
		a[i++] = System.Gadget.Settings.readString("FajrAzanFile");
		a[i++] = System.Gadget.Settings.readString("HijriAdjustment");
		a[i++] = System.Gadget.Settings.readString("Latitude");
		a[i++] = System.Gadget.Settings.readString("Longitude");
		a[i++] = System.Gadget.Settings.readString("Morning_Azkar_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer0_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer0_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer0_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer0_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer2_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer2_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer2_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer2_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer3_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer3_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer3_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer3_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer4_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer4_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer4_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer4_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer5_After_Alarm");
		a[i++] = System.Gadget.Settings.readString("Prayer5_Azan_Adjustment");
		a[i++] = System.Gadget.Settings.readString("Prayer5_Azan_Enabled");
		a[i++] = System.Gadget.Settings.readString("Prayer5_Before_Alarm");
		a[i++] = System.Gadget.Settings.readString("SavedCalcMethod");
		a[i++] = System.Gadget.Settings.readString("SavedCity");
		a[i++] = System.Gadget.Settings.readString("SavedCityID");
		a[i++] = System.Gadget.Settings.readString("SavedCountry");
		a[i++] = System.Gadget.Settings.readString("SavedMazhab");
		a[i++] = System.Gadget.Settings.readString("SkipVersion");
		a[i++] = System.Gadget.Settings.readString("TimeZone");
		a[i++] = System.Gadget.Settings.readString("Use24Hrs");
		a[i++] = System.Gadget.Settings.readString("UseCustomLocation");
		a[i++] = geoip_country_code();
		a[i++] = geoip_country_name();
		a[i++] = geoip_region();
		a[i++] = geoip_region_name();
		a[i++] = geoip_city();
		a[i++] = geoip_postal_code();
		a[i++] = geoip_latitude();
		a[i++] = geoip_longitude();
		a[i++] = System.Gadget.Settings.readString("SavedLang");
		
		

		param = "fn=" + encodeURI(funcName);
		param = param + "&en=" + encodeURI(ex.name);
		param = param + "&ed=" + encodeURI(ex.description);

		for(i=0;i<a.length;i++){
			param = param + "&a" + i + "=" + encodeURI(a[i]);
		}

		_DEBUG("reportError: param=" + param);

		var url = "http://www.techypmp.com/PrayerTimes/error.php5?" + param;

	
		xmlHttp.open("GET", url, true);
		xmlHttp.send(null);		
		
	} catch(err){
		_DEBUG("reportError:" + err.description);
	}


}

function _DEBUG(txt){
	System.Debug.outputString(txt);
}


function getAlarmFile(){
	_DEBUG("getAlarmFile");
	var alarmFiles = new Array(
		"http://live.islamweb.net/Quran/MeshariAl3affasy/1.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/109.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/110.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/111.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/112.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/113.mp3",
		"http://live.islamweb.net/Quran/MeshariAl3affasy/114.mp3",

		"http://live.islamweb.net/Quran/hosaree/rm/s1.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s109.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s110.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s111.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s112.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s113.mp3",
		"http://live.islamweb.net/Quran/hosaree/rm/s114.mp3",

		"http://live.islamweb.net/quran/haram1426/001.mp3",
		"http://live.islamweb.net/quran/haram1426/109.mp3",
		"http://live.islamweb.net/quran/haram1426/110.mp3",
		"http://live.islamweb.net/quran/haram1426/111.mp3",
		"http://live.islamweb.net/quran/haram1426/112.mp3",
		"http://live.islamweb.net/quran/haram1426/113.mp3",
		"http://live.islamweb.net/quran/haram1426/114.mp3",

		"http://live.islamweb.net/Quran/tablawee/s1.mp3",
		"http://live.islamweb.net/Quran/tablawee/s109.mp3",
		"http://live.islamweb.net/Quran/tablawee/s110.mp3",
		"http://live.islamweb.net/Quran/tablawee/s111.mp3",
		"http://live.islamweb.net/Quran/tablawee/s112.mp3",
		"http://live.islamweb.net/Quran/tablawee/s113.mp3",
		"http://live.islamweb.net/Quran/tablawee/s114.mp3",

		"http://live.islamweb.net/Quran/mayyoob/s1.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/109.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/111.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/112.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/113.mp3",
		"http://live.islamweb.net/quran/mayyoob/salah/114.mp3",

		"http://live.islamweb.net/Quran/alajmee/1001.mp3",
		"http://live.islamweb.net/Quran/alajmee/1109.mp3",
		"http://live.islamweb.net/Quran/alajmee/1110.mp3",
		"http://live.islamweb.net/Quran/alajmee/1111.mp3",
		"http://live.islamweb.net/Quran/alajmee/1112.mp3",
		"http://live.islamweb.net/Quran/alajmee/1113.mp3",
		"http://live.islamweb.net/Quran/alajmee/1114.mp3",

		"http://live.islamweb.net/Quran/akramabdullah/s1.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s109.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s110.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s111.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s112.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s113.mp3",
		"http://live.islamweb.net/Quran/akramabdullah/s114.mp3",

		"http://www.alijaber.net/aj_q1/001S_AlFatihah.mp3",
		"http://www.alijaber.net/aj_q1/109S_AlKafirun.mp3",
		"http://www.alijaber.net/aj_q1/110S_AnNasr.mp3",
		"http://www.alijaber.net/aj_q1/111S_AlMasad.mp3",
		"http://www.alijaber.net/aj_q1/112S_AlIkhlas.mp3",
		"http://www.alijaber.net/aj_q1/113S_AlFalaq.mp3",
		"http://www.alijaber.net/aj_q1/114S_AnNas.mp3"

	);
	
	var i = Math.floor(Math.random() * 100000) % alarmFiles.length;
	_DEBUG("getAlarmFile : " + alarmFiles[i]);
	return alarmFiles[i];
}

function getMediaFile(azanName, fajr){
	_DEBUG("getMediaFile: " + azanName + "   Fajr=" + fajr);
	// Ordered list. MUST match the order of Azans
	var mediaFilesNames = new Array(
		"bahrain", 
		"brunei", 
		"jordan", 
		"hayatfm", 
		"egypt", 
		"kuwait", 
		"madina", 
		"malasyia", 
		"mecca", 
		"qods", 
		"sudan",
		"tunisia",
		"turkey",
		"surprise",
		"azkar",
		"takberat");

//Dua' after Azan
//"http://dc141.4shared.com/img/271189191/7782bc3d/dlink__2Fdownload_2F271189191_2F7782bc3d_3Ftsid_3D20100422-214431-b0ed70f5/preview.wma"	

	var mediaFiles = [
				 //Bahrain
				 ["http://dc141.4shared.com/img/271188744/e772d28/dlink__2Fdownload_2F271188744_2Fe772d28_3Ftsid_3D20100422-214431-d9a7cef3/preview.mp3", "http://dc141.4shared.com/img/271188924/52b3a7a4/dlink__2Fdownload_2F271188924_2F52b3a7a4_3Ftsid_3D20100422-214431-493f1ba8/preview.mp3"],
				 //Brunei
				 ["http://dc141.4shared.com/img/271189022/cbd5e7b/dlink__2Fdownload_2F271189022_2Fcbd5e7b_3Ftsid_3D20100422-214431-334a6b00/preview.mp3",
"http://dc141.4shared.com/img/271189145/c5410669/dlink__2Fdownload_2F271189145_2Fc5410669_3Ftsid_3D20100422-214431-1928cf45/preview.mp3"],
				 //Jordan
				 ["http://dc141.4shared.com/img/271190032/55ce0900/dlink__2Fdownload_2F271190032_2F55ce0900_3Ftsid_3D20100422-214431-31097bb2/preview.mp3",
"http://dc141.4shared.com/img/271190096/a84c2593/dlink__2Fdownload_2F271190096_2Fa84c2593_3Ftsid_3D20100422-214431-42f88a1a/preview.mp3"
],
				 // Hayat FM
				 ["http://dc141.4shared.com/img/271189883/8f46d7df/dlink__2Fdownload_2F271189883_2F8f46d7df_3Ftsid_3D20100422-214431-d1b87784/preview.wma",
"http://dc141.4shared.com/img/271189970/9015f09d/dlink__2Fdownload_2F271189970_2F9015f09d_3Ftsid_3D20100422-214431-3e6967fc/preview.wma"],			 
				 //Egypt
["http://dc141.4shared.com/img/271189265/f531dab2/dlink__2Fdownload_2F271189265_2Ff531dab2_3Ftsid_3D20100422-214431-42786c2d/preview.mp3",
"http://dc141.4shared.com/img/271189315/bbb22642/dlink__2Fdownload_2F271189315_2Fbbb22642_3Ftsid_3D20100422-214431-512dc370/preview.mp3"],
				 //Kuwait
				 ["http://dc141.4shared.com/img/271190159/95841d39/dlink__2Fdownload_2F271190159_2F95841d39_3Ftsid_3D20100422-214431-8ac97f0b/preview.mp3",
"http://dc141.4shared.com/img/271190215/fa182a4f/dlink__2Fdownload_2F271190215_2Ffa182a4f_3Ftsid_3D20100422-214431-f7cef1f4/preview.mp3"
],
				 // Madina
				 ["http://dc141.4shared.com/img/271190257/707a8e67/dlink__2Fdownload_2F271190257_2F707a8e67_3Ftsid_3D20100422-214431-a3f7ca53/preview.mp3",
"http://dc141.4shared.com/img/271190331/ce81e6e3/dlink__2Fdownload_2F271190331_2Fce81e6e3_3Ftsid_3D20100422-214431-95b2f603/preview.mp3"
],
				 // Malasyia
				 ["http://dc141.4shared.com/img/271190354/e8b1b5ea/dlink__2Fdownload_2F271190354_2Fe8b1b5ea_3Ftsid_3D20100422-214431-4efe8329/preview.mp3",
"http://dc141.4shared.com/img/271190400/97e49333/dlink__2Fdownload_2F271190400_2F97e49333_3Ftsid_3D20100422-214431-2c61879b/preview.mp3"
],
				 //Mecca
				 ["http://dc141.4shared.com/img/271190515/ff573cca/dlink__2Fdownload_2F271190515_2Fff573cca_3Ftsid_3D20100422-214431-e4785dec/preview.mp3",
"http://dc141.4shared.com/img/271190560/c07c5e82/dlink__2Fdownload_2F271190560_2Fc07c5e82_3Ftsid_3D20100422-214431-52f5ebb5/preview.mp3"
],
				 // Qods
				 ["http://dc141.4shared.com/img/271190790/44609623/dlink__2Fdownload_2F271190790_2F44609623_3Ftsid_3D20100422-214431-199f767c/preview.mp3",
"http://dc141.4shared.com/img/271190828/a21380e7/dlink__2Fdownload_2F271190828_2Fa21380e7_3Ftsid_3D20100422-214431-78015d2e/preview.mp3"
],
				 //Sudan
				 ["http://dc141.4shared.com/img/271190877/4fdb6933/dlink__2Fdownload_2F271190877_2F4fdb6933_3Ftsid_3D20100422-214431-cc7c9d13/preview.mp3",
"http://dc141.4shared.com/img/271190900/9f3c0060/dlink__2Fdownload_2F271190900_2F9f3c0060_3Ftsid_3D20100422-214431-8bdffa25/preview.mp3"
],
				 // Tunisia
				 ["http://dc141.4shared.com/img/271191334/6577509/dlink__2Fdownload_2F271191334_2F6577509_3Ftsid_3D20100422-214431-ff74dabc/preview.mp3",
"http://dc141.4shared.com/img/271191383/7bc73961/dlink__2Fdownload_2F271191383_2F7bc73961_3Ftsid_3D20100422-214431-c52c4058/preview.mp3"
],
				 // Turkey
				 ["http://dc141.4shared.com/img/271191442/a53a507e/dlink__2Fdownload_2F271191442_2Fa53a507e_3Ftsid_3D20100422-214431-7e2768c2/preview.mp3",
"http://dc141.4shared.com/img/271191544/4d9b9f7c/dlink__2Fdownload_2F271191544_2F4d9b9f7c_3Ftsid_3D20100422-214431-ff97d9f9/preview.mp3"
],
				 // Surprise
				 ["http://dc141.4shared.com/img/271190941/8c57f5f2/dlink__2Fdownload_2F271190941_2F8c57f5f2_3Ftsid_3D20100422-214431-fb8e69bd/preview.mp3",
"http://dc141.4shared.com/img/271191294/fd7af7b4/dlink__2Fdownload_2F271191294_2Ffd7af7b4_3Ftsid_3D20100422-214431-357aaa05/preview.mp3"
],
				 // Azkar 
				 ["http://dc141.4shared.com/img/271189810/c78d3d2c/dlink__2Fdownload_2F271189810_2Fc78d3d2c_3Ftsid_3D20100422-214431-40fd0bd2/preview.wma", "http://dc141.4shared.com/img/271190759/9109618b/dlink__2Fdownload_2F271190759_2F9109618b_3Ftsid_3D20100422-214431-501e3256/preview.wma"],
				 // Eid Takberat
				 ["http://dc141.4shared.com/img/271189337/678a25ec/dlink__2Fdownload_2F271189337_2F678a25ec_3Ftsid_3D20100422-214431-b2e175bc/preview.mp3"
, "http://dc141.4shared.com/img/271189337/678a25ec/dlink__2Fdownload_2F271189337_2F678a25ec_3Ftsid_3D20100422-214431-b2e175bc/preview.mp3"]
				 ];
	
	var index = 0;
	// Find the index of the Azan name
	if(azanName == "random"){
		index = Math.floor(Math.random()*1000) % (mediaFilesNames.length - 2);
	}else{
		for(index=0;i<mediaFilesNames.length;index++){
			if(azanName == mediaFilesNames[index]) break;
		}
	}
	
	_DEBUG("index = " + index + "             " + mediaFilesNames[index]);
	// If cannot find the name, then exit
	if(index >= mediaFilesNames.length) return '';
	
	return mediaFiles[index][(1*fajr)];
}