var selected_city='', selected_city_coordinates;
var tz;
var raw_cities;
var serverURL = "http://www.masboston.com/test/";
var map = null;

// Handling city search
var xmlHTTP = new ActiveXObject("Microsoft.XMLHTTP");

var player = new ActiveXObject("WMPlayer.OCX.7");

function _DEBUG(txt){
	System.Debug.outputString(txt);
}

function sortingFunc(a, b){
	//	return a-b; if a<b => -ve, a=b => 0, a>b => +ve
	var temp1 = a.split("|||");
	var temp2 = b.split("|||");
	return (temp1[1]-temp2[1]);
}

function init() {
	
	serverURL = System.Gadget.Settings.readString("ServerURL");
	if(serverURL == '') serverURL = "http://www.techypmp.com/test/";
	_DEBUG("init: serverURL = " + serverURL);
	
	loadStrings();
	
	// Initialize the fields in the dialog box

	// Initialize the fields in the Location tab
	//selectOptionInList(document.all.elsewhere_country,Country);
	selected_city = System.Gadget.Settings.readString("LocationName");
	document.getElementById("selectedcity").innerHTML = "<br><b>"+L_LOC_SELECTED_CITY+": " + selected_city + "</b>";
	
	selected_city_coordinates = System.Gadget.Settings.readString("Latitude") + "|" + System.Gadget.Settings.readString("Longitude");

	_DEBUG("TESTING 1");
	
	// Initialize the fields in the Calculation tab
	selectOptionInList(document.all.calc_method, System.Gadget.Settings.readString("CalcMethod"));
	selectOptionInList(document.all.mazhab, System.Gadget.Settings.readString("Mazhab"));
	selectOptionInList(document.all.hijriAdjustment, System.Gadget.Settings.readString("HijriAdjustment"));
	selectOptionInList(document.all.language, System.Gadget.Settings.readString("Language"));
	updateCalcInfo();
	
	_DEBUG("TESTING 2");
	// Initialize the fields in the Azan tab
	selectedAzanFile = System.Gadget.Settings.readString("AzanFile");
	selectedFajrAzanFile = System.Gadget.Settings.readString("FajrAzanFile");
	initAzanOption();
	_DEBUG("TESTING 3");
	selectOptionInList(document.getElementById("azanVolume"), System.Gadget.Settings.readString("AzanVolume"));
	
	document.getElementById("enableAlarms").checked = (System.Gadget.Settings.readString("AlarmsEnbled") == "True");
	_DEBUG("TESTING 4");
	var i;
	for(i=0;i<6;i++){
		if(i!=1){
			document.getElementById("EnableAzan"+i).checked = (System.Gadget.Settings.readString("Prayer"+i+"_Azan_Enabled") == "True");
			selectOptionInList(document.getElementById("BeforeAlarm"+i), System.Gadget.Settings.readString("Prayer"+i+"_Before_Alarm"));
			selectOptionInList(document.getElementById("AfterAlarm"+i), System.Gadget.Settings.readString("Prayer"+i+"_After_Alarm"));

			selectOptionInList(document.getElementById("AdjustAzan"+i), System.Gadget.Settings.readString("Prayer"+i+"_Azan_Adjustment"));
		}
	}
	_DEBUG("TESTING 5");
	document.getElementById("morningAzkar").checked = (System.Gadget.Settings.readString("Morning_Azkar_Enabled") == "True");
	document.getElementById("morningAzkar").disabled = (document.getElementById("AfterAlarm0").value == -1);
	document.getElementById("eveningAzkar").checked = (System.Gadget.Settings.readString("Evening_Azkar_Enabled") == "True");
	document.getElementById("eveningAzkar").disabled = (document.getElementById("AfterAlarm3").value == -1);

	document.getElementById("Use24Hrs").checked = (System.Gadget.Settings.readString("Use24Hrs") == "True");
	
	document.getElementById("allowAAPPT").checked = (System.Gadget.Settings.readString("allowAAPPT") == "True");
	_DEBUG("TESTING 6");	

	// Disable alarms if needed.
	toggleAlarms();
	_DEBUG("TESTING 7");
	//Initialize the version in the About tab		
	document.getElementById("prayertimesVersion").innerText = System.Gadget.version;
	_DEBUG("TESTING 8");	
	//document.getElementById("emailLink").href="mailto:lassaf@hotmail.com?Subject=Prayer%20Time%20Gadget%20Issue%20("+ System.Gadget.version +")";
	_DEBUG("TESTING");
	
	try{
		map = new VEMap('myMap');
    		map.LoadMap();
    		_DEBUG("init:Map loaded : " + selected_city);
		if(selected_city == "no city selected") DetectLocation();
		
	}catch(ex){
		_DEBUG("map:ex: " + ex.description);
	}

	// Show location tab only.
	showTab('loc');	
}


System.Gadget.onSettingsClosing = function(event) {
	if (event.closeAction == event.Action.commit) {
		System.Gadget.Settings.writeString("LocationName", selected_city);
		
		_DEBUG("selected_city_coordinates = " + selected_city_coordinates);
		if(selected_city_coordinates != ""){
			var coordinates = selected_city_coordinates.split("|");
			System.Gadget.Settings.writeString("Latitude", coordinates[0]);
			System.Gadget.Settings.writeString("Longitude", coordinates[1]);
		}
		
		//System.Gadget.Settings.writeString("TimeZone",  timeZone.value);
		//System.Gadget.Settings.writeString("DaylightSaving", daylightSaving.checked);
		
		System.Gadget.Settings.writeString("CalcMethod", calc_method.value);
		System.Gadget.Settings.writeString("Mazhab", mazhab.value);
		System.Gadget.Settings.writeString("HijriAdjustment", hijriAdjustment.value);
		
		System.Gadget.Settings.writeString("AzanFile", selectedAzanFile);
		System.Gadget.Settings.writeString("FajrAzanFile", selectedFajrAzanFile);
		System.Gadget.Settings.writeString("AzanOption", azanOptions.value);
		System.Gadget.Settings.writeString("AzanVolume", azanVolume.value);
		
		System.Gadget.Settings.writeString("Language", language.value);
		
		System.Gadget.Settings.writeString("AlarmsEnbled", enableAlarms.checked);

		for(i=0;i<6;i++){
			if(i!=1){
				System.Gadget.Settings.writeString("Prayer"+i+"_Azan_Enabled", document.getElementById("EnableAzan"+i).checked);
				System.Gadget.Settings.writeString("Prayer"+i+"_Azan_Adjustment", document.getElementById("AdjustAzan"+i).value);
				System.Gadget.Settings.writeString("Prayer"+i+"_Before_Alarm", document.getElementById("BeforeAlarm"+i).value);
				System.Gadget.Settings.writeString("Prayer"+i+"_After_Alarm", document.getElementById("AfterAlarm"+i).value);	
			}
		}
		
		System.Gadget.Settings.writeString("Morning_Azkar_Enabled", document.getElementById("morningAzkar").checked);
		System.Gadget.Settings.writeString("Evening_Azkar_Enabled", document.getElementById("eveningAzkar").checked);
		
		System.Gadget.Settings.writeString("Use24Hrs", document.getElementById("Use24Hrs").checked);

		System.Gadget.Settings.writeString("allowAAPPT", document.getElementById("allowAAPPT").checked);
		
		
		event.cancel = false;										
		
	}else if(event.closeAction == event.Action.cancel) {
		event.cancel = true;	
	}	

}


function showTab(tab){
	_DEBUG("showTab: " + tab);
	resetAllTabs();
	document.getElementById(tab+'_tab').className='selected';
	document.getElementById(tab+'_content').style.display='';
}

function resetAllTabs(){
	var sections = new Array('loc', 'calc', 'azan', 'alarms', 'about');

	for(i=0;i<sections.length;i++){
		document.getElementById(sections[i]+'_content').style.display='none';
		document.getElementById(sections[i]+'_tab').className='';
	}
}

function selectOptionInList(list, option){
	for(i=0;i<list.options.length;i++){
		if(list.options[i].value == option){
			list.selectedIndex = i;
			break;
		}
	}
}

function searchCities(){
	_DEBUG("searchCities");
	FindAddress();
}

function resetCities(){
//	document.getElementById("cityDetails").style.display = '';
//	document.getElementById("customLocation").style.display = 'none';
	
	document.getElementById("location").style.fontStyle='italic';
	document.getElementById("location").value = L_LOC_SEARCH_CITY;
	document.getElementById("location").style.color='gray';
	

	document.getElementById("location_list").style.display = 'none';
	document.getElementById("L_LOC_CITY_RESET").style.display = 'none';
	document.getElementById("location").style.display = '';
	document.getElementById("L_LOC_CITY_SEARCH").style.display = '';
	document.getElementById('L_LOC_CITY_SEARCH').disabled = true;
	document.getElementById("elsewhere_msg").innerHTML = L_LOC_SEARCH_HINT;
}

function selectCity(){
	_DEBUG("selectCity");
	selected_city_coordinates = document.getElementById("location_list").value;
  	//var coordinates = selected_city_coordinates.split("|");
	_DEBUG(selected_city_coordinates);
  	selected_city = document.getElementById("location_list").options[document.getElementById("location_list").selectedIndex].innerText;
	//L_LOC_SELECTED_CITY = "Current location";
    document.getElementById("selectedcity").innerHTML = "<br><b>"+L_LOC_SELECTED_CITY+": " + selected_city +  "</b>";
}

function playSound(){
	stopSound();
	if(player){
		player.settings.Volume = azanVolume.value;
		player.URL = selectedAzanFile;
		player.controls.play();
		hideElement("playButton");
		stopButton.src = "/images/wait.gif"; 
		setTimeout("stopButton.src=\"/images/stop.gif\";", 1000*5);
		showElement("stopButton");
		//f();
		//saveWebBinary("http://www.masboston.org/test/azan_files/egypt.mp3", "c:\temp\test.bin");
	}
}

function stopSound(){
	if(player){
		player.controls.stop();
		hideElement("stopButton");
		showElement("playButton");
	}
}

function selectAzanOption(){
	_DEBUG("selectAzanOption");
	if(azanOptions.value == 'custom'){
		if(System.Gadget.Settings.readString("AzanOption") == 'custom'){
			document.getElementById("customAzanFile").value = selectedAzanFile;
			document.getElementById("customFajrAzanFile").value = selectedFajrAzanFile;
		}
		showElement('customAzan');
		hideElement('playerCtrl');
	}else if(azanOptions.value == 'random'){
		hideElement('customAzan');		
		hideElement('playerCtrl');
	}else{
		hideElement('customAzan');
		showElement('playerCtrl');
		showElement("playButton");
		hideElement("stopButton");
		_DEBUG("selectAzanOption : " + azanOptions.value);
		selectedAzanFile = getMediaFile(azanOptions.value, 0);
		selectedFajrAzanFile = getMediaFile(azanOptions.value, 1);
		_DEBUG("selectAzanOption : selectedAzanFile = " + selectedAzanFile);
		_DEBUG("selectAzanOption : selectedFajrAzanFile = " + selectedFajrAzanFile);
	}
	stopSound();
}

function initAzanOption(){
	if(System.Gadget.Settings.readString("AzanOption") == 'custom'){
		document.getElementById("customAzanFile").value = selectedAzanFile;
		document.getElementById("customFajrAzanFile").value = selectedFajrAzanFile;
		showElement('customAzan');
		hideElement('playerCtrl');
		//hideElement('stopButton');
	}else if(System.Gadget.Settings.readString("AzanOption") == 'random'){
		hideElement('customAzan');
		hideElement('playerCtrl');
		//hideElement('stopButton');
	}else{
		hideElement('customAzan');
		showElement("playerCtrl");
		showElement('playButton');
		hideElement('stopButton');
	}
	selectOptionInList(document.all.azanOptions, System.Gadget.Settings.readString("AzanOption"));
	stopSound();
}

function playCustomFajrSound(){
	stopCustomSound();
	stopCustomFajrSound();
	if(player && customFajrAzanFile.value != ''){
		player.settings.Volume = azanVolume.value;
		player.URL = customFajrAzanFile.value;
		player.controls.play();
		hideElement("playCustomFajr");
		showElement("stopCustomFajr");
	}
}

function playCustomSound(){
	stopCustomSound();
	stopCustomFajrSound();
	if(player && customAzanFile.value != ''){
		player.settings.Volume = azanVolume.value;
		player.URL = customAzanFile.value;
		player.controls.play();
		hideElement("playCustom");
		showElement("stopCustom");
	}
}

function stopCustomFajrSound(){
	if(player){
		player.controls.stop();
		hideElement("stopCustomFajr");
		showElement("playCustomFajr");
	}
}

function stopCustomSound(){
	if(player){
		player.controls.stop();
		hideElement("stopCustom");
		showElement("playCustom");
	}
}

function updateCustomFajrAzan(){
	var v = customFajrAzanFile.value;
	v = v.replace(/\\/g, '/');
	var file = v.substring(v.lastIndexOf("/")+1);
	//customFajrAzanFileDisplay.innerHTML = file;
}

function updateCustomAzan(){
	var v = customAzanFile.value;
	v = v.replace(/\\/g, '/');
	var file = v.substring(v.lastIndexOf("/")+1);
	//customAzanFileDisplay.innerHTML = file;	
}

function updateCustomAzanDisplay(field, fullpath){
	v = fullpath.replace(/\\/g, '/');
	var file = v.substring(v.lastIndexOf("/")+1);
	document.getElementById(field).innerHTML = file;
}

function CloseCustomAzan(){
	var error = false;
	if(!validFile(customAzanFile.value)){
		otherPrayerFileError.innerText = " Please select a valid file.";
		error = true;
	} else {
		otherPrayerFileError.innerText = "";	
	}

	if(!validFile(customFajrAzanFile.value)){
		fajrPrayerFileError.innerText = " Please select a valid file.";
		error = true;
	} else {
		fajrPrayerFileError.innerText = "";	
	}
	
	if(!error){	
		selectedAzanFile = customAzanFile.value;
		selectedFajrAzanFile = customFajrAzanFile.value;
		
		stopCustomSound();
		stopCustomFajrSound();
		hideElement("customAzan");
	}
}

function CancelCustomAzan(){
	stopCustomSound();
	stopCustomFajrSound();	
	hideElement("customAzan");
	//customFajrAzanFileDisplay.innerHTML = originalFajrAzan;
	//customAzanFileDisplay.innerHTML = originalAzan;
	customAzanFile.value = '';
	customFajrAzanFile.value = '';		
}

function validFile(f){
//f = "C:\\Users\\Loay Assaf\\AppData\\Local\\Microsoft\\Windows Sidebar\\Gadgets\\PrayerTimes.gadget\\includes\\settings.css";
	try{
		var file = System.Shell.itemFromPath(f);
		var x = file.type;
		return true;
	} catch(e){
		return false;
	}
}

function showElement(x){
	document.getElementById(x).style.display = '';
}

function hideElement(x){
	document.getElementById(x).style.display = 'none';
}

function selectFile(v){
	var file = System.Shell.chooseFile(true, "WMA File:*.wma:MP3 File:*.mp3:WAV File:*.wav::",'','');
	try{
		document.getElementById(v).value = file.path;
		//updateCustomAzanDisplay(v+'Display', file.path);
	}catch(ex){
		_DEBUG(ex.description);
	}
}

function toggleAlarms(){
	for(i=0;i<6;i++){
		if(i!=1){
			document.getElementById("BeforeAlarm"+i).disabled = !enableAlarms.checked;
			document.getElementById("AfterAlarm"+ i).disabled = !enableAlarms.checked;
		}
	}
	document.getElementById("morningAzkar").disabled = !enableAlarms.checked;
	document.getElementById("eveningAzkar").disabled = !enableAlarms.checked;	
}

function updateCalcInfo(){
	var txt = "Select a Calculation Method.";
	switch(document.getElementById("calc_method").value){
		case "0": //Jafari
			txt = L_CALC_USED_0;
			break;
		case "2": //Egyptian General Authority of Survey
			txt = L_CALC_USED_2;
			break;
		case "5": //Islamic Society of North America
			txt = L_CALC_USED_5;
			break;
		case "1": //Muslim World League
			txt = L_CALC_USED_1;
			break;
		case "4": //Umm Al-Qura University
			txt = L_CALC_USED_4;
			break;
		case "3": //University of Islamic Sciences, Karachi
			txt = L_CALC_USED_3;
	}
	
	document.getElementById("CalcInfo").innerHTML = txt;
}


function loadStrings(){
	_DEBUG("loadStrings: Loading strings: " + System.Gadget.Settings.readString("Language"));

	try{
		if(System.Gadget.Settings.readString("Language") == '' || System.Gadget.Settings.readString("Language") == 'en'){
			dhtmlLoadScript('../includes/strings.js');
		}else{
			dhtmlLoadScript('../'+ System.Gadget.Settings.readString("Language") + '/includes/strings.js');	
		}
	}catch(ex){
		_DEBUG("loadStrings:ex1:" + ex.description);
		dhtmlLoadScript('../includes/strings.js');
	}	
	
	try{
		document.getElementById("tabs").style.direction = L_DIR;
		document.getElementById("loc_content").style.direction = L_DIR;
		document.getElementById("calc_content").style.direction = L_DIR;
		document.getElementById("azan_content").style.direction = L_DIR;
		document.getElementById("alarms_content").style.direction = L_DIR;
		document.getElementById("about_content").style.direction = L_DIR;
		
		document.getElementById("L_LOC_CITY_SEARCH").value = L_LOC_CITY_SEARCH;
		document.getElementById("L_LOC_CITY_RESET").value = L_LOC_CITY_RESET;
		document.getElementById("L_LOC_AUTO_DETECT").value = L_LOC_AUTO_DETECT;
		document.getElementById("location").value = L_LOC_SEARCH_CITY;

		//for(i=0;i<document.getElementById("calc_method").options.length;i++){
		//	document.getElementById("calc_method").options[i].innerHTML = L_CALC_METHODS[i];
		//}
		localizeList("calc_method", L_CALC_METHODS);
		localizeList("mazhab", L_CALC_MAZHABS);
		localizeList("hijriAdjustment", L_CALC_HIJRI_AJDUSTS);
		localizeList("language", L_CALC_LANGUAGES);
		localizeList("azanOptions", L_AZAN_AZANS);
		localizeList("azanVolume", L_AZAN_VOLUMES);
		
		localizeList("AdjustAzan0", L_AZAN_ADJUSTS);
		localizeList("AdjustAzan2", L_AZAN_ADJUSTS);
		localizeList("AdjustAzan3", L_AZAN_ADJUSTS);
		localizeList("AdjustAzan4", L_AZAN_ADJUSTS);
		localizeList("AdjustAzan5", L_AZAN_ADJUSTS);
		
		localizeList("BeforeAlarm0", L_ALARMS_DELAYS);
		localizeList("AfterAlarm0", L_ALARMS_DELAYS);
		localizeList("BeforeAlarm2", L_ALARMS_DELAYS);
		localizeList("AfterAlarm2", L_ALARMS_DELAYS);
		localizeList("BeforeAlarm3", L_ALARMS_DELAYS);
		localizeList("AfterAlarm3", L_ALARMS_DELAYS);
		localizeList("BeforeAlarm4", L_ALARMS_DELAYS);
		localizeList("AfterAlarm4", L_ALARMS_DELAYS);
		localizeList("BeforeAlarm5", L_ALARMS_DELAYS);
		localizeList("AfterAlarm5", L_ALARMS_DELAYS);
		
		
		var x=document.getElementsByTagName("span");
		for(i=0;i<x.length;i++){
			if(typeof eval(x[i].id) == "string"){
				x[i].innerHTML = eval(x[i].id);
				//_DEBUG(x[i].id + " __ " + eval(x[i].id));
			}
		}
	}catch(ex){
		_DEBUG("loadStrings:ex: " + ex.description);

	}
}


function dhtmlLoadScript(url){
	_DEBUG("dhtmlLoadScript: " + url);
	// Remove old file if exists
	var n=document.getElementsByTagName("head")[0].childNodes;
	for(i=0;i<n.length;i++){
		if(n[i].id == "stringsFile"){
			_DEBUG("dhtmlLoadScript: remove existing link to stringFile: " + i);
			document.getElementsByTagName("head")[0].removeChild(n[i]);
			break;
		}
	}
	
	// Add a new one
	var e = document.createElement("script");
	e.src = url;
	e.type="text/javascript";
	e.id = "stringFile";
	document.getElementsByTagName("head")[0].appendChild(e);
}


function formatStringWithParams(str, params){
	var i, temp = str;
	try{
		for(i=0; i<params.length; i++){
			temp = temp.replace('{'+i+'}', params[i]);
		}
	}catch(ex){
		_DEBUG("convertPrayersToTimes: " + ex.Description);
		//reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
	return temp;
}

function localizeList(listName, listTextArray){
	for(i=0;i<document.getElementById(listName).options.length;i++){
		document.getElementById(listName).options[i].innerHTML = listTextArray[i];
	}
}

function DetectLocation(){
    var x1 = geoip_country_code();
    country = geoip_country_name();
    var x2 = geoip_region();
    var x3 = geoip_region_name();
    city = geoip_city();
    var x4 = geoip_postal_code();
    var address = city + ' ' + x3 + ' ' + country;
    lat = geoip_latitude();
    lon = geoip_longitude();
    _DEBUG("DetectLocation: " + address);
    
    if(map == null){
	    map = new VEMap('myMap');
	    map.LoadMap();
	    _DEBUG("Map loaded");
   	}
	try{
	  	map.Find(null, address, null, null, 0, 10, false, false, false, true, InitializeCity);
	}catch(ex){
		_DEBUG("DetectLocation:ex:" + ex.description);		
	}
}

function FindAddress(){
	var address = document.getElementById('location').value;
	_DEBUG("FindAddress: " + address);
	_DEBUG(map != null);
	try{
		if(address != "") map.Find(null, address, null, null, 0, 10, false, false, false, true, ProcessResults);
	}catch(ex){
		_DEBUG("FindAddress:ex1:" + ex.description);
	}
}
  
function ProcessResults(layer, results, places, hasmore){
	_DEBUG("ProcessResults");
  	if(places != null){
		document.getElementById("location_list").options.length = 0;
		_DEBUG("Places found " + places.length);
		if(places.length >= 1){
			document.getElementById("location").style.display = 'none';
			document.getElementById("L_LOC_CITY_SEARCH").style.display = 'none';
			for(i=0;i<places.length;i++){
				var optionValue =  places[i].LatLong.Latitude + "|" + places[i].LatLong.Longitude;
				var optionText =  places[i].Name;
				_DEBUG(optionText);
				document.getElementById("location_list").options[i] = new Option(optionText, optionValue);
			}
			document.getElementById("location_list").selectedIndex = 0; // preselect the first entry;
			selectCity();
		
			document.getElementById("location_list").style.display = '';
			document.getElementById("location_list").focus();		
			document.getElementById("L_LOC_CITY_RESET").style.display = '';
			document.getElementById("elsewhere_msg").innerHTML = formatStringWithParams(L_LOC_SEARCH_DONE, Array(""+(places.length)));
		}else{
				document.getElementById("elsewhere_msg").innerHTML = "<font color=red>" + L_LOC_NO_CITY + "</font>";
		}
	}
	else{
		_DEBUG("Cannot find location. No search results.");	
		document.getElementById("elsewhere_msg").innerHTML = "<font color=red>" + L_LOC_NO_CITY + "</font>";
	}
}

function InitializeCity(layer, results, places, hasmore){
	_DEBUG("InitializeCity");
	try{
		if(places != null){
			document.getElementById("selectedcity").innerHTML = "<br><b>"+L_LOC_SELECTED_CITY+": " + places[0].Name + "</b>";
			selected_city = places[0].Name;
			selected_city_coordinates = places[0].LatLong.Latitude + "|" + places[0].LatLong.Longitude;
		}else{
			document.getElementById("elsewhere_msg").innerHTML = "<font color=red>" + L_LOC_NO_CITY + "</font>";
			selected_city = "";
			selected_city_coordinates = "";
		}
	}catch(ex){
		_DEBUG("InitializeCity:ex:" + ex.description);
	}
}


